Index: tmp/org.txm.chartsengine.raster.rcp/src/org/txm/chartsengine/raster/rcp/swt/RasterComposite.java
===================================================================
--- tmp/org.txm.chartsengine.raster.rcp/src/org/txm/chartsengine/raster/rcp/swt/RasterComposite.java	(revision 2719)
+++ tmp/org.txm.chartsengine.raster.rcp/src/org/txm/chartsengine/raster/rcp/swt/RasterComposite.java	(revision 2720)
@@ -1,10 +1,13 @@
 package org.txm.chartsengine.raster.rcp.swt;
+
 import java.io.File;
 import java.util.ArrayList;
 
 import org.eclipse.swt.SWT;
 import org.eclipse.swt.graphics.Image;
 import org.eclipse.swt.graphics.ImageData;
+import org.eclipse.swt.layout.GridData;
+import org.eclipse.swt.layout.GridLayout;
 import org.eclipse.swt.widgets.Composite;
 import org.eclipse.swt.widgets.Display;
 import org.eclipse.swt.widgets.Label;
@@ -20,11 +23,12 @@
 
 /**
  * Raster Image SWT composite.
+ * 
  * @author sjacquot
  *
  */
-public class RasterComposite extends ChartComposite	{
-
+public class RasterComposite extends ChartComposite {
+	
 	/**
 	 * The loaded raster image file.
 	 */
@@ -37,83 +41,88 @@
 	
 	/**
 	 * Creates a Raster image composite.
+	 * 
 	 * @param parent
 	 * @param style
 	 */
 	public RasterComposite(ChartEditor chartEditor, Composite parent, int style) {
 		super(chartEditor, parent, style);
-	
 		
+		this.setLayout(new GridLayout(1, false));
+		
 		this.file = null;
 		
-		  //ScrolledComposite sc = new ScrolledComposite( parent, SWT.H_SCROLL | SWT.V_SCROLL );
-	        //GridData layoutData = new GridData( GridData.FILL_HORIZONTAL );
-//	        layoutData.horizontalSpan = 2;
-//	        layoutData.heightHint = 400;
-//	        sc.setLayoutData( layoutData );
-//	 
-	        this.imageLabel = new Label( this, SWT.NONE );
-	        
-//	       // imgLabel.setImage( image );
-//	        this.imageLabel.setSize(  this.imageLabel.computeSize( SWT.DEFAULT, SWT.DEFAULT ));
-//	        sc.setContent(  this.imageLabel );
-	 
-//	        Label l = new Label( shell, SWT.NONE );
-//	        l.setText( "Nom actuel :" );
-//	        layoutData = new GridData();
-//	        layoutData.verticalIndent = 20;
-//	        l.setLayoutData( layoutData );
-//	 
-//	        Text text = new Text( shell, SWT.SINGLE | SWT.BORDER | SWT.READ_ONLY );
-//	        text.setText( "The image name" );
-//	        layoutData = new GridData( GridData.FILL_HORIZONTAL );
-//	        layoutData.verticalIndent = 20;
-//	        text.setLayoutData( layoutData );
+		// ScrolledComposite sc = new ScrolledComposite( parent, SWT.H_SCROLL | SWT.V_SCROLL );
+		// GridData layoutData = new GridData( GridData.FILL_HORIZONTAL );
+		// layoutData.horizontalSpan = 2;
+		// layoutData.heightHint = 400;
+		// sc.setLayoutData( layoutData );
+		//
 		
+		this.imageLabel = new Label(this, SWT.NONE);
+		this.imageLabel.setLayoutData(new GridData(GridData.FILL, GridData.FILL, true, true));
+		this.imageLabel.setText("Nothing loaded yet.");
+		// // imgLabel.setImage( image );
+		// this.imageLabel.setSize( this.imageLabel.computeSize( SWT.DEFAULT, SWT.DEFAULT ));
+		// sc.setContent( this.imageLabel );
 		
-//		Frame frame = SWT_AWT.new_Frame(this);
-//		
-//		// Need to add an AWT Panel to fix mouse events and mouse cursors changes on Swing JPanel
-//		Panel rootPanel = new Panel(new BorderLayout());
-//		this.chartComponent = new SVGPanel(chartEditor, frame);
-//		rootPanel.add(this.getPanel());
-//		frame.add(rootPanel);
-//		frame.pack();
+		// Label l = new Label( shell, SWT.NONE );
+		// l.setText( "Nom actuel :" );
+		// layoutData = new GridData();
+		// layoutData.verticalIndent = 20;
+		// l.setLayoutData( layoutData );
+		//
+		// Text text = new Text( shell, SWT.SINGLE | SWT.BORDER | SWT.READ_ONLY );
+		// text.setText( "The image name" );
+		// layoutData = new GridData( GridData.FILL_HORIZONTAL );
+		// layoutData.verticalIndent = 20;
+		// text.setLayoutData( layoutData );
+		
+		
+		// Frame frame = SWT_AWT.new_Frame(this);
+		//
+		// // Need to add an AWT Panel to fix mouse events and mouse cursors changes on Swing JPanel
+		// Panel rootPanel = new Panel(new BorderLayout());
+		// this.chartComponent = new SVGPanel(chartEditor, frame);
+		// rootPanel.add(this.getPanel());
+		// frame.add(rootPanel);
+		// frame.pack();
 	}
-
-
+	
+	
 	@Override
 	public IChartComponent _createChartComponent() {
 		
 		Object chart = this.chartEditor.getChart();
 		
-		if(chart != null)	{
-			//chartEditorInput.setChartComponent(chart);
+		if (chart != null) {
+			// chartEditorInput.setChartComponent(chart);
 			
 			// sets and updates the local preferences node qualifier from the result data
-			//chartEditorInput.syncLocalPreferencesNode();
-
+			// chartEditorInput.syncLocalPreferencesNode();
+			
 			// FIXME: temporary solution
 			try {
 				this.chartEditor.getResult().compute();
 			}
-			catch(Exception e) {
+			catch (Exception e) {
 				// TODO Auto-generated catch block
 				e.printStackTrace();
 			}
-
 			
+			
 			return (IChartComponent) chart;
 		}
 		
 		
 		return null;
 	}
-
-
-
+	
+	
+	
 	/**
 	 * Loads a raster image from the specified file.
+	 * 
 	 * @param file the file to load
 	 */
 	public void loadRasterFile(File file) {
@@ -121,34 +130,39 @@
 		Log.info(TXMCoreMessages.bind("Loading Raster image from file: {0}...", file));
 		
 		this.file = file;
-		if(this.image != null)	{
+		if (this.image != null) {
 			this.image.dispose();
 		}
 		
 		ImageData imgData = new ImageData(file.getAbsolutePath());
 		this.image = new Image(Display.getCurrent(), imgData);
 		this.imageLabel.setImage(this.image);
-        this.imageLabel.setSize(this.imageLabel.computeSize(SWT.DEFAULT, SWT.DEFAULT));
+		// this.imageLabel.setSize(this.imageLabel.computeSize(SWT.DEFAULT, SWT.DEFAULT));
+		
+		imageLabel.getParent().layout();
 	}
-
 	
 	
-
 	
-//	@Override
-//	public void requestFocusInChartComponent()	{
-//		// FIXME: to check
-////		EventQueue.invokeLater(new Runnable () {
-////			public void run () {
-////				getPanel().requestFocusInWindow();
-////			}
-////		});
-//	}
-
 	
+	
+	// @Override
+	// public void requestFocusInChartComponent() {
+	// // FIXME: to check
+	//// EventQueue.invokeLater(new Runnable () {
+	//// public void run () {
+	//// getPanel().requestFocusInWindow();
+	//// }
+	//// });
+	// }
+	
+	
 	@Override
-	public void loadChart()	{
-//		this.file = (File) this.chartComponent;
+	public void loadChart() {
+		// this.file = (File) this.chartComponent;
+		
+		this.file = this.getChartsEngine().exportChart(this.getChartResult(), 600, 400, this.getChartsEngine().getOutputFormat());
+		
 		this.loadRasterFile(this.file);
 	}
 	
@@ -159,51 +173,51 @@
 	}
 	
 	
-
+	
 	@Override
 	public void copyChartViewToClipboard() {
 		// TODO Auto-generated method stub
 		System.err.println("RasterComposite.copyChartViewToClipboard(): not implemented.");
 	}
-
-
 	
+	
+	
 	@Override
 	public EventCallBackHandler getMouseCallBackHandler() {
-	//	return super.getMouseCallBackHandler(this.getPanel());
+		// return super.getMouseCallBackHandler(this.getPanel());
 		return null;
 	}
-
-
+	
+	
 	@Override
 	public EventCallBackHandler getKeyCallBackHandler() {
 		return null;
-		//return super.getKeyCallBackHandler(this.getPanel());
+		// return super.getKeyCallBackHandler(this.getPanel());
 	}
-
-
-
-
+	
+	
+	
+	
 	@Override
 	public void clearChartItemsSelection() {
 		// TODO Auto-generated method stub
 		System.err.println("RasterComposite.clearChartItemsSelection(): not implemented.");
 	}
-
+	
 	@Override
 	public File exportView(File file, String fileFormat) {
 		System.out.println("RasterComposite.exportView(): not yet implemented.");
 		return null;
 	}
-
-
+	
+	
 	@Override
 	public ArrayList<String> getEditorSupportedExportFileFormats() {
 		// FIXME : no export from web browser PNG, JPEG, see if needed
-		return new ArrayList<String>();
+		return new ArrayList<>();
 	}
-
-
+	
+	
 	@Override
 	public void initEventsListeners() {
 		// TODO Auto-generated method stub
Index: tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/r/RPartitionDimensionsPieChartCreator.java
===================================================================
--- tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/r/RPartitionDimensionsPieChartCreator.java	(revision 2719)
+++ tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/r/RPartitionDimensionsPieChartCreator.java	(revision 2720)
@@ -3,7 +3,6 @@
 import java.io.File;
 import java.util.List;
 
-import org.txm.chartsengine.core.results.ChartResult;
 import org.txm.chartsengine.r.core.RChartCreator;
 import org.txm.chartsengine.r.core.RChartsEngine;
 import org.txm.partition.core.chartsengine.base.Utils;
@@ -18,16 +17,16 @@
  * @author sjacquot
  *
  */
-public class RPartitionDimensionsPieChartCreator extends RChartCreator {
-
+public class RPartitionDimensionsPieChartCreator extends RChartCreator<PartitionDimensions> {
 	
+	
 	@Override
-	public File createChartFile(ChartResult result, File file) {
-
+	public File createChart(PartitionDimensions result, File file) {
+		
 		try {
 			
-			PartitionDimensions partitionDimensions = (PartitionDimensions) result;
-
+			PartitionDimensions partitionDimensions = result;
+			
 			// parameters
 			boolean sortPartsBySize = partitionDimensions.isSortingBySize();
 			boolean displayPartsCountInTitle = partitionDimensions.isDisplayingPartCountInTitle();
@@ -36,53 +35,53 @@
 			
 			// Create parts names command string
 			String snames = "c("; //$NON-NLS-1$
-			for(int i = 0; i < parts.size(); i++) {
+			for (int i = 0; i < parts.size(); i++) {
 				String name = parts.get(i).getName();
-				if(name.trim().length() == 0)
+				if (name.trim().length() == 0)
 					name = "N/A"; //$NON-NLS-1$
 				snames += "\"" + name + "\""; //$NON-NLS-1$ //$NON-NLS-2$
-				if(i != parts.size() - 1)
+				if (i != parts.size() - 1)
 					snames += ","; //$NON-NLS-1$
 			}
 			snames += ")"; //$NON-NLS-1$
-
+			
 			// Create parts sizes command string
 			String ssizes = "c("; //$NON-NLS-1$
-
-			for(int i = 0; i < parts.size(); i++) {
+			
+			for (int i = 0; i < parts.size(); i++) {
 				ssizes += "" + parts.get(i).getSize(); //$NON-NLS-1$
-				if(i != parts.size() - 1)
+				if (i != parts.size() - 1)
 					ssizes += ","; //$NON-NLS-1$
 			}
 			ssizes += ")"; //$NON-NLS-1$
-
+			
 			// colors
-			//this.getChartsEngine().setColors(result.getRenderingColorsMode(),  1);
+			// this.getChartsEngine().setColors(result.getRenderingColorsMode(), 1);
 			// FIXME: one color by part
 			this.getChartsEngine().setColors(result.getRenderingColorsMode(), parts.size());
-
 			
+			
 			String ylab = PartitionCoreMessages.numberOfWords;
-
-			//String cmd = "pie(" + ssizes + ", col=colors, labels=" + snames + ", horiz=F, las=2, ylab=\"" + ylab + "\");\n"; //$NON-NLS-1$
-
+			
+			// String cmd = "pie(" + ssizes + ", col=colors, labels=" + snames + ", horiz=F, las=2, ylab=\"" + ylab + "\");\n"; //$NON-NLS-1$
+			
 			String cmd = String.format("pie(%s, col=colors, labels=%s, horiz=F, las=2, ylab=\"%s\");\n", ssizes, snames, ylab); //$NON-NLS-1$
 			
 			// plot the chart
-			this.getChartsEngine().plot(file, cmd, result, Utils.createPartitionDimensionsChartTitle(partitionDimensions), Utils.createPartitionDimensionsChartSubtitle(partitionDimensions, sortPartsBySize, displayPartsCountInTitle));
-
+			this.getChartsEngine().plot(file, cmd, result, Utils.createPartitionDimensionsChartTitle(partitionDimensions), Utils.createPartitionDimensionsChartSubtitle(partitionDimensions,
+					sortPartsBySize, displayPartsCountInTitle));
+			
 		}
-		catch(Exception e) {
+		catch (Exception e) {
 			Log.severe(PartitionCoreMessages.bind(PartitionCoreMessages.cantCreateDimensionsPartitionChartFileChartsEngineColonP0, RChartsEngine.DESCRIPTION) + e);
 		}
-
+		
 		return file;
 	}
-
-
+	
+	
 	@Override
-	public Class getResultDataClass() {
+	public Class<PartitionDimensions> getResultDataClass() {
 		return PartitionDimensions.class;
 	}
-
-}
\ No newline at end of file
+}
Index: tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/r/RPartitionDimensionsBarChartCreator.java
===================================================================
--- tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/r/RPartitionDimensionsBarChartCreator.java	(revision 2719)
+++ tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/r/RPartitionDimensionsBarChartCreator.java	(revision 2720)
@@ -3,7 +3,6 @@
 import java.io.File;
 import java.util.List;
 
-import org.txm.chartsengine.core.results.ChartResult;
 import org.txm.chartsengine.r.core.RChartCreator;
 import org.txm.chartsengine.r.core.RChartsEngine;
 import org.txm.partition.core.chartsengine.base.Utils;
@@ -18,11 +17,11 @@
  * @author sjacquot
  *
  */
-public class RPartitionDimensionsBarChartCreator extends RChartCreator {
+public class RPartitionDimensionsBarChartCreator extends RChartCreator<PartitionDimensions> {
 
 	
 	@Override
-	public File createChartFile(ChartResult result, File file) {
+	public File createChart(PartitionDimensions result, File file) {
 
 		try {
 			
@@ -85,7 +84,7 @@
 
 
 	@Override
-	public Class getResultDataClass() {
+	public Class<PartitionDimensions> getResultDataClass() {
 		return PartitionDimensions.class;
 	}
 
Index: tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/jfreechart/JFCPartitionDimensionsBarChartCreator.java
===================================================================
--- tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/jfreechart/JFCPartitionDimensionsBarChartCreator.java	(revision 2719)
+++ tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/jfreechart/JFCPartitionDimensionsBarChartCreator.java	(revision 2720)
@@ -1,6 +1,5 @@
 package org.txm.partition.core.chartsengine.jfreechart;
 
-import java.awt.Color;
 import java.util.List;
 
 import org.jfree.chart.JFreeChart;
@@ -11,7 +10,6 @@
 import org.jfree.data.xy.XYSeries;
 import org.jfree.data.xy.XYSeriesCollection;
 import org.txm.chartsengine.core.preferences.ChartsEnginePreferences;
-import org.txm.chartsengine.core.results.ChartResult;
 import org.txm.chartsengine.jfreechart.core.JFCChartCreator;
 import org.txm.chartsengine.jfreechart.core.themes.base.ExtendedNumberAxis;
 import org.txm.chartsengine.jfreechart.core.themes.base.SymbolAxisBetweenTicks;
@@ -28,11 +26,11 @@
  * @author sjacquot
  *
  */
-public class JFCPartitionDimensionsBarChartCreator extends JFCChartCreator {
+public class JFCPartitionDimensionsBarChartCreator extends JFCChartCreator<PartitionDimensions> {
 	
 	
 	@Override
-	public JFreeChart createChart(ChartResult result) {
+	public JFreeChart createChart(PartitionDimensions result) {
 		
 		JFreeChart chart = null;
 		
@@ -50,9 +48,9 @@
 	}
 	
 	@Override
-	public void updateChart(ChartResult result) {
+	public void updateChart(PartitionDimensions result) {
 		
-		PartitionDimensions partitionDimensions = (PartitionDimensions) result;
+		// PartitionDimensions partitionDimensions = (PartitionDimensions) result;
 		JFreeChart chart = (JFreeChart) result.getChart();
 		
 		// freeze rendering while computing
@@ -60,8 +58,8 @@
 		
 		
 		// parameters
-		boolean sortPartsBySize = partitionDimensions.isSortingBySize();
-		boolean displayPartsCountInTitle = partitionDimensions.isDisplayingPartCountInTitle();
+		boolean sortPartsBySize = result.isSortingBySize();
+		boolean displayPartsCountInTitle = result.isDisplayingPartCountInTitle();
 		
 		
 		if (result.hasParameterChanged(ChartsEnginePreferences.CHART_TYPE)
@@ -74,7 +72,7 @@
 			XYSeries series = new XYSeries(PartitionCoreMessages.t);
 			dataset.addSeries(series);
 			
-			List<Part> parts = partitionDimensions.getParts(sortPartsBySize);
+			List<Part> parts = result.getParts(sortPartsBySize);
 			String[] xAxisSymbols = new String[parts.size()];
 			
 			
@@ -96,13 +94,13 @@
 		
 		
 		// Create chart title
-		chart.setTitle(Utils.createPartitionDimensionsChartTitle(partitionDimensions));
+		chart.setTitle(Utils.createPartitionDimensionsChartTitle(result));
 		
 		// Subtitle
 		if (chart.getSubtitleCount() > 0) {
 			chart.removeSubtitle(chart.getSubtitle(0));
 		}
-		chart.addSubtitle(new TextTitle(Utils.createPartitionDimensionsChartSubtitle(partitionDimensions, sortPartsBySize, displayPartsCountInTitle), this.getChartsEngine().getJFCTheme()
+		chart.addSubtitle(new TextTitle(Utils.createPartitionDimensionsChartSubtitle(result, sortPartsBySize, displayPartsCountInTitle), this.getChartsEngine().getJFCTheme()
 				.getSmallFont(),
 				(this.getChartsEngine().getJFCTheme().getAxisLabelPaint()), Title.DEFAULT_POSITION,
 				Title.DEFAULT_HORIZONTAL_ALIGNMENT,
@@ -115,14 +113,8 @@
 		
 	}
 	
-	
 	@Override
-	public Class getResultDataClass() {
+	public Class<PartitionDimensions> getResultDataClass() {
 		return PartitionDimensions.class;
 	}
-	
-	
-	
-	
-	
 }
Index: tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/jfreechart/JFCPartitionDimensionsPieChartCreator.java
===================================================================
--- tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/jfreechart/JFCPartitionDimensionsPieChartCreator.java	(revision 2719)
+++ tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/jfreechart/JFCPartitionDimensionsPieChartCreator.java	(revision 2720)
@@ -1,5 +1,5 @@
 package org.txm.partition.core.chartsengine.jfreechart;
-import java.awt.Color;
+
 import java.util.List;
 
 import org.jfree.chart.JFreeChart;
@@ -9,7 +9,6 @@
 import org.jfree.chart.util.SortOrder;
 import org.jfree.data.general.DefaultPieDataset;
 import org.txm.chartsengine.core.preferences.ChartsEnginePreferences;
-import org.txm.chartsengine.core.results.ChartResult;
 import org.txm.chartsengine.jfreechart.core.JFCChartCreator;
 import org.txm.partition.core.chartsengine.base.Utils;
 import org.txm.partition.core.functions.PartitionDimensions;
@@ -23,31 +22,31 @@
  * @author sjacquot
  *
  */
-public class JFCPartitionDimensionsPieChartCreator extends JFCChartCreator {
-
-
+public class JFCPartitionDimensionsPieChartCreator extends JFCChartCreator<PartitionDimensions> {
+	
+	
 	@Override
-	public Object createChart(ChartResult result) {
+	public JFreeChart createChart(PartitionDimensions result) {
 		
 		JFreeChart chart = null;
-
+		
 		// Creating an empty data set
 		DefaultPieDataset dataset = new DefaultPieDataset();
-
+		
 		// Create the chart
 		chart = this.getChartsEngine().createPieChart(dataset, null, true);
 		
 		return chart;
 	}
-
 	
+	
 	@Override
-	public void updateChart(ChartResult result) {
-
-		PartitionDimensions partitionDimensions = (PartitionDimensions) result;
+	public void updateChart(PartitionDimensions result) {
+		
+		PartitionDimensions partitionDimensions = result;
 		JFreeChart chart = (JFreeChart) result.getChart();
-
 		
+		
 		// freeze rendering while computing
 		chart.setNotify(false);
 		
@@ -55,54 +54,55 @@
 		// parameters
 		boolean sortPartsBySize = partitionDimensions.isSortingBySize();
 		boolean displayPartsCountInTitle = partitionDimensions.isDisplayingPartCountInTitle();
-
-
-		if(result.hasParameterChanged(ChartsEnginePreferences.CHART_TYPE)
-				|| result.hasParameterChanged(PartitionDimensionsPreferences.CHART_DIMENSIONS_SORT_BY_SIZE))	{
+		
+		
+		if (result.hasParameterChanged(ChartsEnginePreferences.CHART_TYPE)
+				|| result.hasParameterChanged(PartitionDimensionsPreferences.CHART_DIMENSIONS_SORT_BY_SIZE)) {
 			
 			// Fill the data set from the result
-			DefaultPieDataset dataset = (DefaultPieDataset)((PiePlot) chart.getPlot()).getDataset();
+			DefaultPieDataset dataset = (DefaultPieDataset) ((PiePlot) chart.getPlot()).getDataset();
 			dataset.clear();
 			
 			try {
-	
+				
 				List<Part> parts = partitionDimensions.getParts(sortPartsBySize);
-	
-				for (int i = 0 ; i < parts.size() ; i++) {
+				
+				for (int i = 0; i < parts.size(); i++) {
 					dataset.setValue(parts.get(i).getName(), parts.get(i).getSize());
 				}
-	
-				if(sortPartsBySize)	{
+				
+				if (sortPartsBySize) {
 					dataset.sortByValues(SortOrder.ASCENDING);
 				}
-				else	{
+				else {
 					dataset.sortByKeys(SortOrder.ASCENDING);
 				}
 			}
-			catch(CqiClientException e) {
+			catch (CqiClientException e) {
 				e.printStackTrace();
 			}
 		}
-
+		
 		// Create chart title
 		chart.setTitle(Utils.createPartitionDimensionsChartTitle(partitionDimensions));
-
+		
 		// Subtitle
-		if(chart.getSubtitleCount() > 0)	{
-			chart.removeSubtitle(chart.getSubtitle(0));	
+		if (chart.getSubtitleCount() > 0) {
+			chart.removeSubtitle(chart.getSubtitle(0));
 		}
-		chart.addSubtitle(new TextTitle(Utils.createPartitionDimensionsChartSubtitle(partitionDimensions, sortPartsBySize, displayPartsCountInTitle), this.getChartsEngine().getJFCTheme().getSmallFont(),
-				((Color)this.getChartsEngine().getJFCTheme().getAxisLabelPaint()), Title.DEFAULT_POSITION,
-                Title.DEFAULT_HORIZONTAL_ALIGNMENT,
-                Title.DEFAULT_VERTICAL_ALIGNMENT, Title.DEFAULT_PADDING));
-
+		chart.addSubtitle(new TextTitle(Utils.createPartitionDimensionsChartSubtitle(partitionDimensions, sortPartsBySize, displayPartsCountInTitle), this.getChartsEngine().getJFCTheme()
+				.getSmallFont(),
+				(this.getChartsEngine().getJFCTheme().getAxisLabelPaint()), Title.DEFAULT_POSITION,
+				Title.DEFAULT_HORIZONTAL_ALIGNMENT,
+				Title.DEFAULT_VERTICAL_ALIGNMENT, Title.DEFAULT_PADDING));
 		
+		
 		super.updateChart(result);
 		
 	}
 	
 	@Override
-	public Class getResultDataClass() {
+	public Class<PartitionDimensions> getResultDataClass() {
 		return PartitionDimensions.class;
 	}
 }
Index: tmp/org.txm.progression.core/src/org/txm/progression/core/chartsengine/r/RProgressionBaseChartCreator.java
===================================================================
--- tmp/org.txm.progression.core/src/org/txm/progression/core/chartsengine/r/RProgressionBaseChartCreator.java	(revision 2719)
+++ tmp/org.txm.progression.core/src/org/txm/progression/core/chartsengine/r/RProgressionBaseChartCreator.java	(revision 2720)
@@ -8,13 +8,12 @@
 import java.util.List;
 
 import org.apache.commons.lang.StringEscapeUtils;
-import org.txm.chartsengine.core.preferences.ChartsEnginePreferences;
-import org.txm.chartsengine.core.results.ChartResult;
 import org.txm.chartsengine.r.core.RChartCreator;
 import org.txm.chartsengine.r.core.themes.DefaultTheme;
 import org.txm.progression.core.chartsengine.base.ProgressionChartCreator;
 import org.txm.progression.core.chartsengine.base.Utils;
 import org.txm.progression.core.functions.Progression;
+import org.txm.progression.core.preferences.ProgressionPreferences;
 import org.txm.statsengine.r.core.RWorkspace;
 import org.txm.statsengine.r.core.exceptions.RWorkspaceException;
 import org.txm.utils.logger.Log;
@@ -26,7 +25,7 @@
  * @author sjacquot
  *
  */
-public class RProgressionBaseChartCreator extends RChartCreator implements ProgressionChartCreator {
+public abstract class RProgressionBaseChartCreator extends RChartCreator<Progression> implements ProgressionChartCreator {
 	
 	
 	
@@ -38,12 +37,14 @@
 	 * @param cumulative
 	 * @return
 	 */
-	public File createChartFile(ChartResult result, File file, boolean cumulative) {
+	public File createChart(Progression result, File file, boolean cumulative) {
 		
 		try {
 			
-			Progression progression = (Progression) result;
+			Progression progression = result;
 			
+			// boolean cumulative = result.getBooleanParameterValue(ProgressionPreferences.CHART_CUMULATIVE);
+			
 			// parameters
 			int renderingColorMode = progression.getRenderingColorsMode();
 			
@@ -177,17 +178,16 @@
 		return -1;
 	}
 	
-	
 	@Override
-	public Class getResultDataClass() {
-		return Progression.class;
-	}
-	
-	@Override
 	public ArrayList<ArrayList<Integer>> getAllPointPositionsBySeries(Object chart) {
 		Log.severe(this.getClass() + ".getAllPointPositionsBySeries(): Not yet implemented."); //$NON-NLS-1$
 		return null;
 	}
 	
 	
+	@Override
+	public Class<Progression> getResultDataClass() {
+		return Progression.class;
+	}
+	
 }
Index: tmp/org.txm.progression.core/src/org/txm/progression/core/chartsengine/r/RProgressionCumulativeChartCreator.java
===================================================================
--- tmp/org.txm.progression.core/src/org/txm/progression/core/chartsengine/r/RProgressionCumulativeChartCreator.java	(revision 2719)
+++ tmp/org.txm.progression.core/src/org/txm/progression/core/chartsengine/r/RProgressionCumulativeChartCreator.java	(revision 2720)
@@ -3,6 +3,7 @@
 import java.io.File;
 
 import org.txm.chartsengine.core.results.ChartResult;
+import org.txm.progression.core.functions.Progression;
 
 // FIXME: SJ: this chart creator has been disabled in extension definition to force JFC mode for Cumulative chart and R mode for Density chart since the Density chart is not yet implemented in JFC charts engine  
 /**
@@ -12,12 +13,11 @@
  *
  */
 public class RProgressionCumulativeChartCreator extends RProgressionBaseChartCreator {
-
-
+	
+	
 	@Override
-	public File createChartFile(ChartResult result, File file) {
-		return super.createChartFile(result, file, true);
+	public File createChart(Progression result, File file) {
+		return super.createChart(result, file, true);
 	}
-
-
+	
 }
Index: tmp/org.txm.progression.core/src/org/txm/progression/core/chartsengine/r/RProgressionDensityChartCreator.java
===================================================================
--- tmp/org.txm.progression.core/src/org/txm/progression/core/chartsengine/r/RProgressionDensityChartCreator.java	(revision 2719)
+++ tmp/org.txm.progression.core/src/org/txm/progression/core/chartsengine/r/RProgressionDensityChartCreator.java	(revision 2720)
@@ -2,7 +2,7 @@
 
 import java.io.File;
 
-import org.txm.chartsengine.core.results.ChartResult;
+import org.txm.progression.core.functions.Progression;
 
 /**
  * R progression density chart creator.
@@ -11,12 +11,12 @@
  *
  */
 public class RProgressionDensityChartCreator extends RProgressionBaseChartCreator {
-
-
+	
+	
 	@Override
-	public File createChartFile(ChartResult result, File file) {
-		return super.createChartFile(result, file, false);
+	public File createChart(Progression result, File file) {
+		return super.createChart(result, file, false);
 	}
-
-
+	
+	
 }
Index: tmp/org.txm.progression.core/src/org/txm/progression/core/chartsengine/jfreechart/JFCProgressionCumulativeChartCreator.java
===================================================================
--- tmp/org.txm.progression.core/src/org/txm/progression/core/chartsengine/jfreechart/JFCProgressionCumulativeChartCreator.java	(revision 2719)
+++ tmp/org.txm.progression.core/src/org/txm/progression/core/chartsengine/jfreechart/JFCProgressionCumulativeChartCreator.java	(revision 2720)
@@ -34,14 +34,14 @@
  * @author sjacquot
  *
  */
-public class JFCProgressionCumulativeChartCreator extends JFCChartCreator implements ProgressionChartCreator {
+public class JFCProgressionCumulativeChartCreator extends JFCChartCreator<Progression> implements ProgressionChartCreator {
 	
 	
 	@Override
-	public JFreeChart createChart(ChartResult result) {
+	public JFreeChart createChart(Progression result) {
 		
 		
-		Progression progression = (Progression) result;
+		Progression progression = result;
 		
 		// parameters
 		boolean cumulative = result.getBooleanParameterValue(ProgressionPreferences.CHART_CUMULATIVE);
@@ -116,9 +116,9 @@
 	
 	
 	@Override
-	public void updateChart(ChartResult result) {
+	public void updateChart(Progression result) {
 		
-		Progression progression = (Progression) result;
+		Progression progression = result;
 		JFreeChart chart = (JFreeChart) result.getChart();
 		
 		// freeze rendering while computing
Index: tmp/org.txm.chartsengine.jfreechart.core/src/org/txm/chartsengine/jfreechart/core/JFCChartsEngine.java
===================================================================
--- tmp/org.txm.chartsengine.jfreechart.core/src/org/txm/chartsengine/jfreechart/core/JFCChartsEngine.java	(revision 2719)
+++ tmp/org.txm.chartsengine.jfreechart.core/src/org/txm/chartsengine/jfreechart/core/JFCChartsEngine.java	(revision 2720)
@@ -32,6 +32,7 @@
 import org.txm.chartsengine.jfreechart.core.themes.base.JFCTheme;
 import org.txm.chartsengine.jfreechart.core.themes.base.SymbolAxisBetweenTicks;
 import org.txm.chartsengine.jfreechart.core.themes.highcharts.defaulttheme.HighchartsDefaultTheme;
+import org.txm.utils.logger.Log;
 
 import com.lowagie.text.Document;
 import com.lowagie.text.Rectangle;
@@ -436,12 +437,28 @@
 		return jfcTheme;
 	}
 	
-	
+	//
 	@Override
-	public File createChartFile(Object chart, File file) {
-		return this.export((JFreeChart) chart, file);
+	public File exportChart(ChartResult result, File file, int imageWidth, int imageHeight, String outputFormat) {
+		Object chart = result.getChart();
+		if (chart == null) {
+			Log.severe("Error: null chart in " + result);
+			return null;
+		}
+		if (chart instanceof JFreeChart) {
+			return exportChart(chart, file, outputFormat, imageWidth, imageHeight); // create & write a
+		}
+		else {
+			Log.severe("Error: the chart is not a JFreeChart " + chart + " " + result);
+			return null;
+		}
 	}
 	
+	// @Override
+	// public File createChartFile(Object chart, File file, String outputFormat) {
+	// return this.export((JFreeChart) chart, file);
+	// }
+	
 	@Override
 	public File exportChart(Object chart, File file, String outputFormat, int imageWidth, int imageHeight, int drawingAreaX, int drawingAreaY, int drawingAreaWidth, int drawingAreaHeight) {
 		return JFCChartsEngine.export(chart, file, outputFormat, imageWidth, imageHeight, drawingAreaX, drawingAreaY, drawingAreaWidth, drawingAreaHeight);
@@ -578,7 +595,7 @@
 	public static File exportRasterImage(JFreeChart chart, File file, String outputFormat, int imageWidth, int imageHeight, int drawingAreaX, int drawingAreaY, int drawingAreaWidth,
 			int drawingAreaHeight) {
 		
-		BufferedImage bufferedImage = ((JFreeChart) chart).createBufferedImage(imageWidth, imageHeight, BufferedImage.TYPE_INT_RGB, null);
+		BufferedImage bufferedImage = chart.createBufferedImage(imageWidth, imageHeight, BufferedImage.TYPE_INT_RGB, null);
 		
 		// Crop
 		bufferedImage = bufferedImage.getSubimage(drawingAreaX, drawingAreaY, drawingAreaWidth, drawingAreaHeight);
@@ -854,7 +871,7 @@
 	
 	@Override
 	public ArrayList<String> getSupportedOutputDisplayFormats() {
-		ArrayList<String> formats = new ArrayList<String>(1);
+		ArrayList<String> formats = new ArrayList<>(1);
 		
 		formats.add(OUTPUT_FORMAT_JFC_JAVA2D);
 		
@@ -863,7 +880,7 @@
 	
 	@Override
 	public ArrayList<String> getSupportedOutputFileFormats() {
-		ArrayList<String> formats = new ArrayList<String>(6);
+		ArrayList<String> formats = new ArrayList<>(6);
 		
 		formats.add(OUTPUT_FORMAT_SVG); // Default format
 		
